module Game(
  nextState
  ) where

import Data.Array
import Cmd
import State

moveToPos :: Move -> State-> Maybe Pos
moveToPos m st =
  let p' = case (m, self st) of
        (Up, (x, y)) -> (x, y- 1)
        (RU, (x, y)) -> (x+ 1, y- 1)
        (Ri, (x, y)) -> (x+ 1, y)
        (RD, (x, y)) -> (x+ 1, y+ 1)
        (Do, (x, y)) -> (x, y+ 1)
        (LD, (x, y)) -> (x- 1, y+ 1)
        (Le, (x, y)) -> (x- 1, y)
        (LU, (x, y)) -> (x- 1, y- 1)
        (Idle, (x, y)) -> (x, y)
  in if validPos st p' then Just p' else Nothing

nextState :: Move-> State-> State
nextState m st = 
  incMov $ case moveToPos m st of
    Nothing -> st
    Just p | not (fields st ! p) -> st {self= p}
           | otherwise -> st -- hit an obstacle
