module Main where

import Control.Concurrent(threadDelay)
import Data.Array
import System.IO

import State
import Game
import Cmd


printState :: State-> IO ()
printState st = do
  putStrLn "\ESC[H\ESC[2J"  -- tput clear, effective only on Linux
  putStrLn $ render st

-- Game main loop
loop :: State-> IO ()
loop st = do
  printState st
  threadDelay 10000
  c <- getCmd
  case c of
    Move m -> loop (nextState m st) 
    Quit -> putStrLn "Good bye!"

-- Main entry point
main :: IO ()
main = do
  putStrLn "Setting up..."      
  hSetBuffering stdin NoBuffering -- This does nothing under windows
  i<- initialState 50 20
  loop i
